/* C program for the implementation of RSA algorithm */

#include<stdio.h>
#include<string.h>
#include<time.h>
#include<sys/time.h>
#include<sys/times.h>
#include<unistd.h>
#include<stdlib.h>

int phi,M,n,e,d,C,FLAG,d_lg;
int tab[50];


int check()
{
  int i;
  for(i=3;e%i==0 && phi%i==0;i+2)
    {
      FLAG = 1;
      return;
    }
  FLAG = 0;
}

void encrypt()
{
  int i;
  C = 1;
  for(i=0;i< e;i++)
    C=C*M%n;
  C = C%n;
  printf("\n\tEncrypted keyword : %d",C);
}


// fonction qui lit dans le registre TSC (Time Stamp Counter)
__inline__ unsigned long long int rdtsc()
 {
    unsigned long long int x;
    __asm__ volatile (".byte 0x0f, 0x31" : "=A" (x));     
    return x;  
 }


void decrypt()
{
  int i;
  int s[d_lg];
  int R[d_lg];

  unsigned long long int start, end;
  
  int ecart=0;
  int ecart_bis=0;
  int ind_ecart, ind_ecart_bis;
  int j;

  // structure de donnes pour les temps d'excution
  typedef struct data{
  int time;
  int ind;
  struct data *suiv;
  } data;

  data *data_list=NULL;
  data *d;
 

  s[0]=1;
  for(i=0;i<d_lg;i++){
    /*********** CALCUL DE TEMPS ****************/
    start=rdtsc();

    if (tab[d_lg-1-i]==1){
      R[i]=s[i]*C%n;
    } else {
      R[i]=s[i];
    }

    /*********** CALCUL DE TEMPS ****************/
    end=rdtsc();
    printf("temps de l'itration %d: %d\n",i,(end-start));    


    s[i+1]=(R[i]*R[i])%n;
    

    // tri par temps d'excution
    d=data_list;
    data *new=(data *)malloc(sizeof(data));
    new->time=(end-start);
    new->ind=i;
    if (data_list==NULL){
      data_list=new;
    } else if (new->time < data_list->time){
      new->suiv=data_list;
      data_list=new;
    } else {
      while (d->suiv!=NULL && (d->suiv->time < new->time)){
	d=d->suiv;
      }
      if (d->suiv==NULL){
	d->suiv=new;
      } else {
	new->suiv=d->suiv;
	d->suiv=new;
      }
    }
  }

  // calcul plus grand cart et indices correspondants
  d=data_list;
  j=0;
  while (d!=NULL){
    if (j>=(d_lg/3)-1 && j<=d_lg-(d_lg/3)-1 && d->suiv!=NULL && (d->suiv->time - d->time)>ecart){
      ecart=(d->suiv->time - d->time);
      ind_ecart=j;
    } else if (d->suiv!=NULL && (d->suiv->time - d->time)>ecart){
      ecart_bis=(d->suiv->time - d->time);
      ind_ecart_bis=j;
    }
    d=d->suiv;
    j++;
  }

  if (ecart==0){
    ecart=ecart_bis;
    ind_ecart=ind_ecart_bis;
  }

  // impression de la clef
  d=data_list;
  j=0;
  while (j<=ind_ecart){
    printf("d[%d]=0\n",d->ind);
    d=d->suiv;
    j++;
  }
  while (d!=NULL){
    printf("d[%d]=1\n",d->ind);
    d=d->suiv;
  }

  // libration des lments
  d=data_list;
  data *f;
  while(d!=NULL){
    f=d;
    d=d->suiv;
    f->suiv=NULL;
    free(f);
  }

  M=R[d_lg-1];
  printf("\n\tDecrypted keyword : %c\n",M);
}

void convert(){
  /* convert d in binary */
  int q, r, i, j;
  q=1;
  i=0;
  while( q != 0 )
    {
      q=d/2;
      r=d%2;
      d=q;
      
      tab[i++]=r;
      j=i;
    }
  
  for(i=j-1;i>=0;i--)
    printf("%d",tab[i]);
  printf("\n");
  d_lg=j;
}

int main()
{
  int i;
  int p,q,s;
  char pt[24];
  printf("Enter Two Relatively Prime Numbers\t: ");
  scanf("%d%d",&p,&q);
  n = p*q;
  phi=(p-1)*(q-1);
  printf("\n\tF(n)\t= %d\n",phi);
  do
    {
      printf("\n\nEnter e\t: ");
      scanf("%d",&e);
      check();
    }while(FLAG==1);
  d = 1;
  do
    {
      s = (d*e)%phi;
      d++;
    }while(s!=1);
  d = d-1;
  printf("\n\tPublic Key\t: {%d,%d}",e,n);
  printf("\n\tPrivate Key\t: {%d,%d}\n",d,n);
  convert();
  printf("\n\nEnter The Plain Text\t: ");
  scanf("%s",&pt);
  for (i=0; i<strlen(pt); i++){
    M=(int)pt[i];
    encrypt();
  }
  printf("\n\nEnter the Cipher text\t: ");
  for (i=0; i<strlen(pt); i++){
    scanf("%d",&C);
    decrypt();
  }
  printf("\n");
  return 0;
}